Index: trunk/source/geometry/solids/CSG/include/G4Trd.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Trd.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Trd.icc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Trd.icc,v 1.7 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/include/G4Tubs.hh
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Tubs.hh	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Tubs.hh	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Tubs.hh,v 1.21 2008/11/06 10:55:40 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Tubs.hh,v 1.22 2009/03/26 16:25:44 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
@@ -86,5 +86,5 @@
       // Constructs a tubs with the given name and dimensions
 
-    virtual ~G4Tubs();
+   ~G4Tubs();
       //
       // Destructor
@@ -103,5 +103,5 @@
     inline void SetOuterRadius   (G4double newRMax);
     inline void SetZHalfLength   (G4double newDz);
-    inline void SetStartPhiAngle (G4double newSPhi);
+    inline void SetStartPhiAngle (G4double newSPhi, G4bool trig=true);
     inline void SetDeltaPhiAngle (G4double newDPhi);
     
@@ -159,5 +159,5 @@
     inline G4double GetDPhi() const;
 
-  protected:
+  private:
 
     G4ThreeVectorList*
@@ -167,20 +167,13 @@
       // for G4VSolid:: ClipCrossSection and ClipBetweenSections
 
-    G4double fRMin, fRMax, fDz, fSPhi, fDPhi;
-    G4bool fPhiFullTube;
-   
-      // Used by distanceToOut
-
-    enum ESide {kNull,kRMin,kRMax,kSPhi,kEPhi,kPZ,kMZ};
-
-      // Used by normal
-
-    enum ENorm {kNRMin,kNRMax,kNSPhi,kNEPhi,kNZ};
-
-  private:
-
     inline void Initialize();
       //
       // Reset relevant values to zero
+
+    inline void CheckSPhiAngle(G4double sPhi);
+    inline void CheckDPhiAngle(G4double dPhi);
+    inline void CheckPhiAngles(G4double sPhi, G4double dPhi);
+      //
+      // Reset relevant flags and angle values
 
     inline void InitializeTrigonometry();
@@ -195,12 +188,28 @@
   private:
 
+    // Used by distanceToOut
+    //
+    enum ESide {kNull,kRMin,kRMax,kSPhi,kEPhi,kPZ,kMZ};
+
+    // Used by normal
+    //
+    enum ENorm {kNRMin,kNRMax,kNSPhi,kNEPhi,kNZ};
+
     G4double kRadTolerance, kAngTolerance;
       //
       // Radial and angular tolerances
 
+    G4double fRMin, fRMax, fDz, fSPhi, fDPhi;
+      //
+      // Radial and angular dimensions
+   
     G4double sinCPhi, cosCPhi, cosHDPhiOT, cosHDPhiIT,
              sinSPhi, cosSPhi, sinEPhi, cosEPhi;
       //
       // Cached trigonometric values
+
+    G4bool fPhiFullTube;
+      //
+      // Flag for identification of section or full tube
 };
 
Index: trunk/source/geometry/solids/CSG/include/G4Tubs.icc
===================================================================
--- trunk/source/geometry/solids/CSG/include/G4Tubs.icc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/include/G4Tubs.icc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Tubs.icc,v 1.11 2008/11/06 10:55:40 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Tubs.icc,v 1.14 2009/06/09 16:08:23 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
@@ -91,4 +91,55 @@
 }
 
+inline void G4Tubs::CheckSPhiAngle(G4double sPhi)
+{
+  // Ensure fSphi in 0-2PI or -2PI-0 range if shape crosses 0
+
+  if ( sPhi < 0 )
+  {
+    fSPhi = twopi - std::fmod(std::fabs(sPhi),twopi);
+  }
+  else
+  {
+    fSPhi = std::fmod(sPhi,twopi) ;
+  }
+  if ( fSPhi+fDPhi > twopi )
+  {
+    fSPhi -= twopi ;
+  }
+}
+
+inline void G4Tubs::CheckDPhiAngle(G4double dPhi)
+{
+  fPhiFullTube = true;
+  if ( dPhi >= twopi-kAngTolerance*0.5 )
+  {
+    fDPhi=twopi;
+    fSPhi=0;
+  }
+  else
+  {
+    fPhiFullTube = false;
+    if ( dPhi > 0 )
+    {
+      fDPhi = dPhi;
+    }
+    else
+    {
+      G4cerr << "ERROR - G4Tubs()::CheckDPhiAngle()" << G4endl
+             << "        Negative or zero delta-Phi (" << dPhi << ") in solid: "
+             << GetName() << G4endl;
+      G4Exception("G4Tubs::CheckDPhiAngle()", "InvalidSetup",
+                  FatalException, "Invalid dphi.");
+    }
+  }
+}
+
+inline void G4Tubs::CheckPhiAngles(G4double sPhi, G4double dPhi)
+{
+  CheckDPhiAngle(dPhi);
+  if ( (fDPhi<twopi) && (sPhi) ) { CheckSPhiAngle(sPhi); }
+  InitializeTrigonometry();
+}
+
 inline
 void G4Tubs::SetInnerRadius (G4double newRMin)
@@ -113,9 +164,13 @@
 
 inline
-void G4Tubs::SetStartPhiAngle (G4double newSPhi)
-{
-  fSPhi= newSPhi;
-  Initialize();
-  InitializeTrigonometry();
+void G4Tubs::SetStartPhiAngle (G4double newSPhi, G4bool compute)
+{
+  // Flag 'compute' can be used to explicitely avoid recomputation of
+  // trigonometry in case SetDeltaPhiAngle() is invoked afterwards
+
+  CheckSPhiAngle(newSPhi);
+  fPhiFullTube = false;
+  if (compute)  { InitializeTrigonometry(); }
+  Initialize();
 }
 
@@ -123,22 +178,6 @@
 void G4Tubs::SetDeltaPhiAngle (G4double newDPhi)
 {
-  if ( newDPhi >= twopi-kAngTolerance*0.5 )
-  {
-    fPhiFullTube = true;
-  }
-  else if ( newDPhi > 0 )
-  {
-    fPhiFullTube = false;
-  }
-  else
-  {
-     G4cerr << "ERROR - G4Tubs()::SetDeltaPhiAngle() : " << GetName() << G4endl
-            << "        Negative delta-Phi ! - " << newDPhi << G4endl;
-     G4Exception("G4Tubs::SetDeltaPhiAngle()", "InvalidSetup",
-                  FatalException, "Invalid dphi.");
-  }
-  fDPhi= newDPhi;
-  Initialize();
-  InitializeTrigonometry();
+  CheckPhiAngles(fSPhi, newDPhi);
+  Initialize();
 }
 
Index: trunk/source/geometry/solids/CSG/src/G4Box.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Box.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Box.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Box.cc,v 1.44 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // 
Index: trunk/source/geometry/solids/CSG/src/G4CSGSolid.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4CSGSolid.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4CSGSolid.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4CSGSolid.cc,v 1.13 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // --------------------------------------------------------------------
Index: trunk/source/geometry/solids/CSG/src/G4Cons.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Cons.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Cons.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Cons.cc,v 1.60 2008/11/06 15:26:53 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Cons.cc,v 1.67 2009/11/12 11:53:11 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //
@@ -35,4 +35,6 @@
 // History:
 //
+// 12.10.09 T.Nikitina: Added to DistanceToIn(p,v) check on the direction in
+//                      case of point on surface
 // 03.05.05 V.Grichine: SurfaceNormal(p) according to J. Apostolakis proposal
 // 13.09.96 V.Grichine: Review and final modifications
@@ -79,11 +81,11 @@
                       G4double pDz,
                       G4double pSPhi, G4double pDPhi)
-  : G4CSGSolid(pName)
+  : G4CSGSolid(pName), fSPhi(0), fDPhi(0)
 {
-  // Check z-len
-
   kRadTolerance = G4GeometryTolerance::GetInstance()->GetRadialTolerance();
   kAngTolerance = G4GeometryTolerance::GetInstance()->GetAngularTolerance();
 
+  // Check z-len
+  //
   if ( pDz > 0 )
   {
@@ -100,5 +102,5 @@
 
   // Check radii
-
+  //
   if ( (pRmin1<pRmax1) && (pRmin2<pRmax2) && (pRmin1>=0) && (pRmin2>=0) )
   {
@@ -121,42 +123,7 @@
   }
 
-  fPhiFullCone = true;
-  if ( pDPhi >= twopi-kAngTolerance*0.5 ) // Check angles
-  {
-    fDPhi=twopi;
-    fSPhi=0;
-  }
-  else
-  {
-    fPhiFullCone = false;
-    if ( pDPhi > 0 )
-    {
-      fDPhi = pDPhi;
-    }
-    else
-    {
-      G4cerr << "ERROR - G4Cons()::G4Cons(): " << GetName() << G4endl
-             << "        Negative delta-Phi ! - "
-             << pDPhi << G4endl;
-      G4Exception("G4Cons::G4Cons()", "InvalidSetup",
-                  FatalException, "Invalid dphi.");
-    }
-
-    // Ensure fSphi in 0-2PI or -2PI-0 range if shape crosses 0
-
-    if ( pSPhi < 0 )
-    {
-      fSPhi = twopi - std::fmod(std::fabs(pSPhi),twopi);
-    }
-    else
-    {
-      fSPhi = std::fmod(pSPhi,twopi) ;
-    }
-    if ( fSPhi+fDPhi > twopi )
-    {
-      fSPhi -= twopi ;
-    }
-  }
-  InitializeTrigonometry();
+  // Check angles
+  //
+  CheckPhiAngles(pSPhi, pDPhi);
 }
 
@@ -705,5 +672,5 @@
 {
   G4double snxt = kInfinity ;      // snxt = default return value
-
+  const G4double dRmax = 100*std::min(fRmax1,fRmax2);
   static const G4double halfCarTolerance=kCarTolerance*0.5;
   static const G4double halfRadTolerance=kRadTolerance*0.5;
@@ -717,9 +684,11 @@
   G4double tolODz,tolIDz ;
 
-  G4double Dist,s,xi,yi,zi,ri=0.,rhoi2,cosPsi ; // Intersection point variables
+  G4double Dist,s,xi,yi,zi,ri=0.,risec,rhoi2,cosPsi ; // Intersection point vars
 
   G4double t1,t2,t3,b,c,d ;    // Quadratic solver variables 
   G4double nt1,nt2,nt3 ;
   G4double Comp ;
+
+  G4ThreeVector Normal;
 
   // Cone Precalcs
@@ -887,4 +856,9 @@
         if ( s > 0 )  // If 'forwards'. Check z intersection
         {
+          if ( s>dRmax ) // Avoid rounding errors due to precision issues on
+          {              // 64 bits systems. Split long distances and recompute
+            G4double fTerm = s-std::fmod(s,dRmax);
+            s = fTerm + DistanceToIn(p+fTerm*v,v);
+          } 
           zi = p.z() + s*v.z() ;
 
@@ -917,12 +891,22 @@
       {
         // Inside cones, delta r -ve, inside z extent
-
+        // Point is on the Surface => check Direction using  Normal.dot(v)
+
+        xi     = p.x() ;
+        yi     = p.y()  ;
+        risec  = std::sqrt(xi*xi + yi*yi)*secRMax ;
+        Normal = G4ThreeVector(xi/risec,yi/risec,-tanRMax/secRMax) ;
         if ( !fPhiFullCone )
         {
           cosPsi = (p.x()*cosCPhi + p.y()*sinCPhi)/std::sqrt(t3) ;
-
-          if (cosPsi >= cosHDPhiIT)  { return 0.0; }
-        }
-        else  { return 0.0; }
+          if ( cosPsi >= cosHDPhiIT )
+          {
+            if ( Normal.dot(v) <= 0 )  { return 0.0; }
+          }
+        }
+        else
+        {             
+          if ( Normal.dot(v) <= 0 )  { return 0.0; }
+        }
       }
     }
@@ -972,5 +956,5 @@
 
   if (rMinAv)
-  {
+  { 
     nt1 = t1 - (tanRMin*v.z())*(tanRMin*v.z()) ;
     nt2 = t2 - tanRMin*v.z()*rin ;
@@ -993,4 +977,9 @@
           if ( s >= 0 )   // > 0
           {
+            if ( s>dRmax ) // Avoid rounding errors due to precision issues on
+            {              // 64 bits systems. Split long distance and recompute
+              G4double fTerm = s-std::fmod(s,dRmax);
+              s = fTerm + DistanceToIn(p+fTerm*v,v);
+            } 
             zi = p.z() + s*v.z() ;
 
@@ -1004,7 +993,31 @@
                 cosPsi = (xi*cosCPhi + yi*sinCPhi)/ri ;
 
-                if (cosPsi >= cosHDPhiIT)  { snxt = s; }
+                if (cosPsi >= cosHDPhiIT)
+                { 
+                  if ( s > halfRadTolerance )  { snxt=s; }
+                  else
+                  {
+                    // Calculate a normal vector in order to check Direction
+
+                    risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                    Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin);
+                    if ( Normal.dot(v) <= 0 )  { snxt = s; }
+                  } 
+                }
               }
-              else  { return s; }
+              else
+              {
+                if ( s > halfRadTolerance )  { return s; }
+                else
+                {
+                  // Calculate a normal vector in order to check Direction
+
+                  xi     = p.x() + s*v.x() ;
+                  yi     = p.y() + s*v.y() ;
+                  risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                  Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin) ;
+                  if ( Normal.dot(v) <= 0 )  { return s; }
+                }
+              }
             }
           }
@@ -1032,4 +1045,9 @@
             if ( (s >= 0) && (std::fabs(zi) <= tolODz) )  // s > 0
             {
+              if ( s>dRmax ) // Avoid rounding errors due to precision issues
+              {              // seen on 64 bits systems. Split and recompute
+                G4double fTerm = s-std::fmod(s,dRmax);
+                s = fTerm + DistanceToIn(p+fTerm*v,v);
+              } 
               if ( !fPhiFullCone )
               {
@@ -1038,7 +1056,31 @@
                 cosPsi = (xi*cosCPhi + yi*sinCPhi)/ri ;
 
-                if (cosPsi >= cosHDPhiOT)  { snxt = s; }
+                if (cosPsi >= cosHDPhiOT)
+                {
+                  if ( s > halfRadTolerance )  { snxt=s; }
+                  else
+                  {
+                    // Calculate a normal vector in order to check Direction
+
+                    risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                    Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin);
+                    if ( Normal.dot(v) <= 0 )  { snxt = s; } 
+                  }
+                }
               }
-              else  { return s; }
+              else
+              {
+                if( s > halfRadTolerance )  { return s; }
+                else
+                {
+                  // Calculate a normal vector in order to check Direction
+
+                  xi     = p.x() + s*v.x() ;
+                  yi     = p.y() + s*v.y() ;
+                  risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                  Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin) ;
+                  if ( Normal.dot(v) <= 0 )  { return s; }
+                } 
+              }
             }
           }
@@ -1051,4 +1093,9 @@
             if ( (s >= 0) && (ri > 0) && (std::fabs(zi) <= tolODz) ) // s>0
             {
+              if ( s>dRmax ) // Avoid rounding errors due to precision issues
+              {              // seen on 64 bits systems. Split and recompute
+                G4double fTerm = s-std::fmod(s,dRmax);
+                s = fTerm + DistanceToIn(p+fTerm*v,v);
+              } 
               if ( !fPhiFullCone )
               {
@@ -1057,7 +1104,31 @@
                 cosPsi = (xi*cosCPhi + yi*sinCPhi)/ri ;
 
-                if (cosPsi >= cosHDPhiIT)  { snxt = s; }
+                if (cosPsi >= cosHDPhiIT)
+                {
+                  if ( s > halfRadTolerance )  { snxt=s; }
+                  else
+                  {
+                    // Calculate a normal vector in order to check Direction
+
+                    risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                    Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin);
+                    if ( Normal.dot(v) <= 0 )  { snxt = s; } 
+                  }
+                }
               }
-              else  { return s; }
+              else
+              {
+                if ( s > halfRadTolerance )  { return s; }
+                else
+                {
+                  // Calculate a normal vector in order to check Direction
+
+                  xi     = p.x() + s*v.x() ;
+                  yi     = p.y() + s*v.y() ;
+                  risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+                  Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin) ;
+                  if ( Normal.dot(v) <= 0 )  { return s; }
+                } 
+              }
             }
           }
@@ -1099,5 +1170,5 @@
               zi = p.z() + s*v.z() ;
               ri = rMinAv + zi*tanRMin ;
-
+              
               if ( ri > 0 )   // 2nd root
               {
@@ -1107,4 +1178,9 @@
                 if ( (s >= 0) && (std::fabs(zi) <= tolODz) )  // s>0
                 {
+                  if ( s>dRmax ) // Avoid rounding errors due to precision issue
+                  {              // seen on 64 bits systems. Split and recompute
+                    G4double fTerm = s-std::fmod(s,dRmax);
+                    s = fTerm + DistanceToIn(p+fTerm*v,v);
+                  } 
                   if ( !fPhiFullCone )
                   {
@@ -1136,4 +1212,9 @@
             if ( (s >= 0) && (std::fabs(zi) <= tolODz) )  // s>0
             {
+              if ( s>dRmax ) // Avoid rounding errors due to precision issues
+              {              // seen on 64 bits systems. Split and recompute
+                G4double fTerm = s-std::fmod(s,dRmax);
+                s = fTerm + DistanceToIn(p+fTerm*v,v);
+              } 
               if ( !fPhiFullCone )
               {
@@ -1335,5 +1416,5 @@
   // Vars for intersection within tolerance
 
-  ESide    sidetol ;
+  ESide    sidetol = kNull ;
   G4double slentol = kInfinity ;
 
@@ -1669,7 +1750,14 @@
             xi     = p.x() + slentol*v.x() ;
             yi     = p.y() + slentol*v.y() ;
-            risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
-            Normal = G4ThreeVector(xi/risec,yi/risec,-tanRMin/secRMin) ;
-            
+            if( sidetol==kRMax )
+            {
+              risec  = std::sqrt(xi*xi + yi*yi)*secRMax ;
+              Normal = G4ThreeVector(xi/risec,yi/risec,-tanRMax/secRMax) ;
+            }
+            else
+            {
+              risec  = std::sqrt(xi*xi + yi*yi)*secRMin ;
+              Normal = G4ThreeVector(-xi/risec,-yi/risec,tanRMin/secRMin) ;
+            }
             if( Normal.dot(v) > 0 )
             {
Index: trunk/source/geometry/solids/CSG/src/G4Orb.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Orb.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Orb.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4Orb.cc,v 1.24 2007/05/18 07:38:01 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4Orb.cc,v 1.30 2009/11/30 10:20:38 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Orb
@@ -298,4 +298,6 @@
   rad2 = p.x()*p.x()+p.y()*p.y()+p.z()*p.z() ;
 
+  G4double rad = std::sqrt(rad2);
+
   // G4double rad = std::sqrt(rad2);
   // Check radial surface
@@ -304,10 +306,10 @@
   tolRMax = fRmax - fRmaxTolerance*0.5 ;
     
-  if ( rad2 <= tolRMax*tolRMax )  in = kInside ;
+  if ( rad <= tolRMax )  { in = kInside ; }
   else
   {
     tolRMax = fRmax + fRmaxTolerance*0.5 ;       
-    if ( rad2 <= tolRMax*tolRMax ) in = kSurface ;
-    else                           in = kOutside ;
+    if ( rad <= tolRMax )  { in = kSurface ; }
+    else                   { in = kOutside ; }
   }
   return in;
@@ -360,4 +362,6 @@
   G4double c, d2, s = kInfinity ;
 
+  const G4double dRmax = 100.*fRmax;
+
   // General Precalcs
 
@@ -384,5 +388,7 @@
   // => s=-pDotV3d+-std::sqrt(pDotV3d^2-(rad2-R^2))
 
-  c = rad2 - fRmax*fRmax ;
+
+  G4double rad = std::sqrt(rad2);
+  c = (rad - fRmax)*(rad + fRmax);
 
   if ( c > fRmaxTolerance*fRmax )
@@ -396,7 +402,13 @@
     {
       s = -pDotV3d - std::sqrt(d2) ;
-
-      if (s >= 0 ) return snxt = s;
-           
+      if ( s >= 0 )
+      {
+        if ( s>dRmax ) // Avoid rounding errors due to precision issues seen on
+        {              // 64 bits systems. Split long distances and recompute
+          G4double fTerm = s-std::fmod(s,dRmax);
+          s = fTerm + DistanceToIn(p+fTerm*v,v);
+        } 
+        return snxt = s;
+      }
     }
     else    // No intersection with G4Orb
@@ -410,8 +422,14 @@
     {
       d2 = pDotV3d*pDotV3d - c ;             
-      //  if ( pDotV3d >= 0 ) return snxt = kInfinity;
-      if ( d2 < fRmaxTolerance*fRmax || pDotV3d >= 0 ) return snxt = kInfinity;
-      else                return snxt = 0.;
-    }
+      if ( (d2 < fRmaxTolerance*fRmax) || (pDotV3d >= 0) )
+      {
+        return snxt = kInfinity;
+      }
+      else
+      {
+        return snxt = 0.;
+      }
+    }
+#ifdef G4CSGDEBUG
     else // inside ???
     {
@@ -419,4 +437,5 @@
                   JustWarning, "Point p is inside !?");
     }
+#endif
   }
   return snxt;
@@ -431,7 +450,8 @@
 G4double G4Orb::DistanceToIn( const G4ThreeVector& p ) const
 {
-  G4double safe=0.0, rad  = std::sqrt(p.x()*p.x()+p.y()*p.y()+p.z()*p.z());
-                 safe = rad - fRmax;
-  if( safe < 0 ) safe = 0. ;
+  G4double safe = 0.0,
+           rad  = std::sqrt(p.x()*p.x()+p.y()*p.y()+p.z()*p.z());
+  safe = rad - fRmax;
+  if( safe < 0 ) { safe = 0.; }
   return safe;
 }
@@ -475,10 +495,11 @@
   
   const G4double  Rmax_plus = fRmax + fRmaxTolerance*0.5;
-
-  if( rad2 <= Rmax_plus*Rmax_plus )
-  {
-    c = rad2-fRmax*fRmax ;
-
-    if ( c < fRmaxTolerance*fRmax) 
+  G4double rad = std::sqrt(rad2);
+
+  if ( rad <= Rmax_plus )
+  {
+    c = (rad - fRmax)*(rad + fRmax);
+
+    if ( c < fRmaxTolerance*fRmax ) 
     {
       // Within tolerant Outer radius 
Index: trunk/source/geometry/solids/CSG/src/G4Para.cc
===================================================================
--- trunk/source/geometry/solids/CSG/src/G4Para.cc	(revision 1227)
+++ trunk/source/geometry/solids/CSG/src/G4Para.cc	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4Para.cc,v 1.39 2006/10/19 15:33:37 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4Para
